【HDU - 4791】【Alice's Print Service】

题目:

Alice is providing print service, while the pricing doesn't seem to be reasonable, so people using her print service found some tricks to save money. 
For example, the price when printing less than 100 pages is 20 cents per page, but when printing not less than 100 pages, you just need to pay only 10 cents per page. It's easy to figure out that if you want to print 99 pages, the best choice is to print an extra blank page so that the money you need to pay is 100 × 10 cents instead of 99 × 20 cents. 
Now given the description of pricing strategy and some queries, your task is to figure out the best ways to complete those queries in order to save money.

Input

The first line contains an integer T (≈ 10) which is the number of test cases. Then T cases follow. 
Each case contains 3 lines. The first line contains two integers n, m (0 < n, m ≤ 10 5 ). The second line contains 2n integers s 1, p 1 , s 2, p 2 , ..., s n, p n (0=s1 < s 2 < ... < s n ≤ 10 9 , 10 9 ≥ p 1 ≥ p 2 ≥ ... ≥ p n ≥ 0).. The price when printing no less than s i but less than s i+1 pages is p i cents per page (for i=1..n-1). The price when printing no less than s n pages is p n cents per page. The third line containing m integers q 1 .. q m (0 ≤ q i ≤ 10 9 ) are the queries.

Output

For each query q i, you should output the minimum amount of money (in cents) to pay if you want to print q i pages, one output in one line.

Sample Input

1
2 3
0 20 100 10
0 99 100

Sample Output

0
1000
1000

题意:爱丽丝的打印店有个奇怪的规矩,她将打印数量分为了n个阶段,每个阶段都有着不同的打印价格,然后我们输入这些数据,份数价格,然后输入m个打印份数,我们求解最小的花费,

解题思路:上来就想暴力,发现不现实,数据给到1e5,暴力求解的话肯定会 T,然后考虑到二分的时间复杂度大大减小,就决定使用二分来进行实现找到当前输入数据的所在区间,(能省时间复杂度就尽力省,然而,我使用的lower_bound 和upper_bound的效果是一样的,已知lower_bound返回的是第一个大于等于所查找数字的位置,upper_bound返回的是第一个大于所查找数字的位置,很奇妙,假设数据有 0,100,200,我们分别用lower_bound,upper_bound查找100的位置是不同的,很奇妙,最后zxz大佬总结,数据出水了。= =

咱们寻找到合适的区间后,直接求一下正确的值,emmm,关键来了,咱们要求解一下之后有没有那种虽然打印的多,但是花钱少的可能,按理说,直接for循环突破,但是已经有O(n)的复杂度了,如果再在内部嵌套,直接升为O(mn)的复杂度了,然后会T ,所以线段树求解一下,寻找咱们二分查找到的位置之后到结尾区间内的最小值,然后比较取小就可以了。

ac代码:

#include<cstdio>
#include<iostream>
#include<cstring>
#include<algorithm>
#define maxn 800005
#define inf 0x3f3f3f3f3f3f3f3f
using namespace std;
typedef long long ll;
int n,m;
struct node{
	int l;
	int r;
	ll val;
}tree[maxn];
ll tm[maxn];
ll x[maxn],y[maxn];
void pushup(int cur)
{
	tree[cur].val=min(tree[cur<<1].val,tree[cur<<1|1].val);
}
void build(int l,int r,int cur)
{
	tree[cur].l=l;
	tree[cur].r=r;
	if(l==r)
	{
		tree[cur].val=tm[l];
		return ;	
	}
	int mid=(l+r)>>1;
	build(l,mid,cur<<1);
	build(mid+1,r,cur<<1|1);
	pushup(cur);
}
ll query(int lt,int rt,int cur)
{
	if(tree[cur].l>=lt&&tree[cur].r<=rt)
		return tree[cur].val;
	int mid=(tree[cur].l+tree[cur].r)>>1;
	ll ans=inf;
	if(mid>=lt)
		 ans=min(ans,query(lt,rt,cur<<1));
	if(mid+1<=rt)
	 ans=min(ans,query(lt,rt,cur<<1|1));	
		return ans;
}
int main()
{
	int t;
	scanf("%d",&t);
	while(t--)
	{
		scanf("%d%d",&n,&m);
		for(int i=1;i<=n;i++)
		{
			scanf("%lld%lld",&x[i],&y[i]);	
			tm[i]=x[i]*y[i];	
		}
		build(1,n,1);
		while(m--)
		{
			ll a;
			scanf("%lld",&a);
			int pos=upper_bound(x+1,x+1+n,a)-1-x;
			ll res=a*y[pos];
//			printf("res%lld\n",res);
			ll ans=query(pos+1,n,1);
//			printf("ans%lld\n",ans);
			ans=min(res,ans);
			if(pos<n)
				printf("%lld\n",ans);
			else
				printf("%lld\n",res);
		}	
	}	
	return 0;
} 

 

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值